#ifndef _CREATETRIGGERS_CPP
#define _CREATETRIGGERS_CPP
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include <Windows.H>
#include <WindowsX.H>
#include <ShellAPI.H>
#include <Stdio.H>
#include <Stdlib.H>
#include <SQL.H>
#include <SQLExt.H>

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "../Resources/Resource.H"
#include "../../SharedClasses/CRC32/CRC.H"
#include "../../SharedClasses/SQLClass/cSQL.H"
#include "../../SharedClasses/SQLClass/cRecordSet.H"
#include "../SockServer/SockServer.H"

#include "NSWFL.H"
#include "Init.H"
#include "Entry.H"
#include "Routines.H"
#include "CreateTriggers.H"

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void CreateTriggersTest(void)
{
	CREATE_TRIGGER_TABLE MyCrtTable;

	MyCrtTable.sDriver = "{SQL Server}";
	MyCrtTable.sServer = "(Local)";
	MyCrtTable.sUserName  = "sa";
	MyCrtTable.sPassword = "";

	MyCrtTable.sDatabase = "JT_BTDevelop";

	MyCrtTable.sSourceTableDBO = "dbo";
	MyCrtTable.sSourceTableName = "GLDetail";

	MyCrtTable.sTargetTableDBO = "dbo";
	MyCrtTable.sTargetTableName = "WP_GLDetail";

	CreateTriggerTable(&MyCrtTable);

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

bool CreateTriggerTable(LPCREATE_TRIGGER_TABLE MyCrtTable)
{
	int iPKCount = 0;

	char sFullSourceTableName[1024];
	char sFullTargetTableName[1024];

    char **sPrimaryKeys = NULL;  
    int iPrimaryKeys = 0;      

	char sTriggerTable[1024];
	//char sPKList[1024];
	//char sWhere[1024];
	char sSQL[1024];
	char *sBaseSQL = NULL;

    CSQL cSQL;
	CRecordSet rsTemp;

	//----------------------------------------------------------------------------------------

	if(!cSQL.Connect(MyCrtTable->sDriver, MyCrtTable->sServer, MyCrtTable->sUserName, MyCrtTable->sPassword, MyCrtTable->sDatabase))
	{
		MsgBox("Failed to connect.");
		return false;
	}

	sprintf(sFullSourceTableName, "[%s].[%s].[%s]", MyCrtTable->sDatabase, MyCrtTable->sSourceTableDBO, MyCrtTable->sSourceTableName);
	sprintf(sFullTargetTableName, "[%s].[%s].[%s]", MyCrtTable->sDatabase, MyCrtTable->sTargetTableDBO, MyCrtTable->sTargetTableName);

	//----------------------------------------------------------------------------------------
	// Clean up any existing triggers and tables.

	sprintf(sSQL, "drop table %s", MyCrtTable->sTargetTableName);
	cSQL.ExecuteNonQuery(sSQL);

	sprintf(sSQL, "drop trigger %s_WP_Deleted", MyCrtTable->sSourceTableName);
	cSQL.ExecuteNonQuery(sSQL);

	sprintf(sSQL, "drop trigger %s_WP_Inserted", MyCrtTable->sSourceTableName);
	cSQL.ExecuteNonQuery(sSQL);

	sprintf(sSQL, "drop trigger %s_WP_Updated", MyCrtTable->sSourceTableName);
	cSQL.ExecuteNonQuery(sSQL);

	//----------------------------------------------------------------------------------------

	if((sPrimaryKeys = GetPrimaryKeys(&cSQL, sFullSourceTableName, &iPrimaryKeys)) == NULL)
	{
		MsgBox("Failed to get a list of primary key columns.");
		return false;
	}

	//----------------------------------------------------------------------------------------

	strcpy(sTriggerTable, "CREATE TABLE %s_WP_Deleted\r\n");
	strcat(sTriggerTable, "(\r\n");
	strcat(sTriggerTable, " \tWP_ID INT IDENTITY(1,1),");

	iPKCount = 0;
	while(sPrimaryKeys[iPKCount])
	{
		strcat(sTriggerTable, "\r\n\t[");
		strcat(sTriggerTable, sPrimaryKeys[iPKCount]);
		strcat(sTriggerTable, "] VARCHAR(50),");

		iPKCount++;
	}

    strcat(sTriggerTable, " \r\n\tCONSTRAINT MyTestTable_PK PRIMARY KEY (WP_ID)\r\n");
	strcat(sTriggerTable, ")");

	MsgBox(sTriggerTable);

	//----------------------------------------------------------------------------------------

	/*
	//----------------------------------------------------------------------------------------
	// Clean up any existing triggers and tables.

	sprintf(sSQL, "drop table %s", MyCrtTable->sTargetTableName);
	cSQL.ExecuteNonQuery(sSQL);

	sprintf(sSQL, "drop trigger Deleted_%s", MyCrtTable->sSourceTableName);
	cSQL.ExecuteNonQuery(sSQL);

	sprintf(sSQL, "drop trigger Inserted_%s", MyCrtTable->sSourceTableName);
	cSQL.ExecuteNonQuery(sSQL);

	sprintf(sSQL, "drop trigger Updated_%s", MyCrtTable->sSourceTableName);
	cSQL.ExecuteNonQuery(sSQL);
	
	//----------------------------------------------------------------------------------------
	// Copy the table.

	sprintf(sSQL, "SELECT * INTO %s FROM %s WHERE 1 = 0", sFullTargetTableName, sFullSourceTableName);

	if(!cSQL.ExecuteNonQuery(sSQL))
	{
		MsgBox("Failed to create the new table.");
		return false;
	}

	if((sPrimaryKeys = GetPrimaryKeys(&cSQL, sFullSourceTableName, &iPrimaryKeys)) == NULL)
	{
		MsgBox("Failed to get a list of primary key columns.");
		return false;
	}

	//----------------------------------------------------------------------------------------
	//Create primary keys on target table.

	sBaseSQL = "ALTER TABLE %s ADD CONSTRAINT [PK_%s]\r\n"
		" PRIMARY KEY CLUSTERED (\r\n";

	sprintf(sSQL, sBaseSQL, MyCrtTable->sTargetTableName, MyCrtTable->sTargetTableName);

	while(sPrimaryKeys[iPKCount])
	{
		if(iPKCount > 0)
		{
			strcat(sSQL, ",\r\n");
		}

		strcat(sSQL, "\t[");
		strcat(sSQL, sPrimaryKeys[iPKCount]);
		strcat(sSQL, "]");

		iPKCount++;
	}

	strcat(sSQL, "\r\n) ON [PRIMARY]");

	if(iPKCount > 0)
	{
		if(!cSQL.ExecuteNonQuery(sSQL))
		{
			MsgBox("Failed to create new primary key.");
			return false;
		}
	}

	rsTemp.Close();

	//----------------------------------------------------------------------------------------
	//Create Triggers on the source table.

	strcpy(sPKList, "");
	strcpy(sWhere, "Where ");
		
	iPKCount = 0;
	while(sPrimaryKeys[iPKCount])
	{
		if(iPKCount > 0)
		{
			strcat(sPKList, ",");
			strcat(sWhere, " AND ");
		}

		strcat(sPKList, "[");
		strcat(sPKList, sPrimaryKeys[iPKCount]);
		strcat(sPKList, "]");

		strcat(sWhere, "[");
		strcat(sWhere, sPrimaryKeys[iPKCount]);
		strcat(sWhere, "] = \r\n\t(select [Deleted].[");
		strcat(sWhere, sPrimaryKeys[iPKCount]);
		strcat(sWhere, "] from Deleted)");

		iPKCount++;
	}

	sBaseSQL = "CREATE TRIGGER Deleted_%s ON %s.%s AFTER DELETE AS\r\n"
		" BEGIN\r\n"
		" INSERT INTO %s.%s (%s) (SELECT %s FROM Deleted)\r\;\r\n"
		" DELETE FROM %s.%s %s\r\;\r\n"
		" DELETE FROM %s.%s %s\r\;\r\n"
		" END\r\n";

	//sprintf(sTriggerTable, 
	
	sprintf(sSQL, sBaseSQL,
		MyCrtTable->sSourceTableName,//
		MyCrtTable->sSourceTableDBO,//
		MyCrtTable->sSourceTableName,//

		MyCrtTable->sTargetTableDBO,//
		MyCrtTable->sTargetTableName,// Needs to be the name of the [WP_Table_Deleted] table.

		sPKList,//Insert this.
		sPKList,//Select this.

		MyCrtTable->sTargetTableDBO, 
		MyCrtTable->sTargetTableName, // Needs to be the name of the [WP_Table_Inserted] table.
		sWhere,

		MyCrtTable->sTargetTableDBO, 
		MyCrtTable->sTargetTableName, // Needs to be the name of the [WP_Table_Inserted] table.
		sWhere
	);

		MsgBox(sSQL);

	if(!cSQL.ExecuteNonQuery(sSQL))
	{
		MsgBox("Failed to create \"delete\" trigger");
		return false;
	}
*/
	/*
	GO
CREATE TRIGGER [Inserted_SlsOrdDet] ON [dbo].[SlsOrdDet] AFTER INSERT AS
BEGIN
	INSERT INTO [WP_Dellinger_Changes].[dbo].[WP_Inserted_SlsordDet](Table_ID) (SELECT [ID] FROM Inserted)
END
GO
CREATE TRIGGER [Updated_SlsOrdDet] ON [dbo].[SlsOrdDet] AFTER UPDATE AS
BEGIN
	INSERT INTO [WP_Dellinger_Changes].[dbo].[WP_Updated_SlsordDet](Table_ID) (SELECT [ID] FROM Inserted)
END
GO
*/
	
	return true;
}
	
////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

char **GetPrimaryKeys(CSQL *pcSQL, char *sTableName, int *iNumOfKeys)
{
	int iPKCount = 0;
	int iPKColLen = 0;

	char sSQL[1024];
	char sPKCol[256];
	char *sBaseSQL = NULL;
	char **sOutKeys = NULL;

    CRecordSet rsTemp;

	sBaseSQL = "SELECT sysobjects.parent_obj AS tableid, 'PK' AS constraintType,"
		" sysobjects.name AS constraintName, syscolumns.name AS keyColumn, sysindexkeys.KeyNo"
		" FROM sysobjects"
		" INNER JOIN sysindexes ON sysobjects.name = sysindexes.name"
		" INNER JOIN sysindexkeys ON sysindexes.indid = sysindexkeys.indid AND sysindexes.id = sysindexkeys.id"
		" INNER JOIN syscolumns ON sysindexkeys.colid = syscolumns.colid AND sysobjects.parent_obj = syscolumns.id"
		" WHERE sysobjects.xtype = 'PK' and sysobjects.parent_obj = object_id('%s')"
		" Order by sysindexkeys.KeyNo";

	sprintf(sSQL, sBaseSQL, sTableName);

	if(!pcSQL->Execute(sSQL, &rsTemp))
	{
		return NULL;
	}

	if(rsTemp.RowCount > 0)
	{
		sOutKeys = (char **) calloc(sizeof(char *), rsTemp.RowCount + 1);

		while(rsTemp.Fetch())
		{
			rsTemp.sColumnEx(4, sPKCol, sizeof(sPKCol), &iPKColLen);

			if(iPKColLen > 0)
			{
				sOutKeys[iPKCount] = (char *) calloc(sizeof(char), iPKColLen + 1);
				strcpy(sOutKeys[iPKCount], sPKCol);
				iPKCount++;
			}
		}
		sOutKeys[iPKCount] = NULL;
	}
	else{
		sOutKeys = NULL;
	}

	rsTemp.Close();
	
	*iNumOfKeys = iPKCount;

	return sOutKeys;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

void FreePrimaryKeys(char **sOutKeys, int iKeys)
{
	int iPos = 0;

	if(iKeys > 0)
	{
		while(iPos < iKeys)
		{
			free(sOutKeys[iPos]);
			iPos++;
		}
	}
	else{
		while(sOutKeys[iPos])
		{
			free(sOutKeys[iPos]);
			iPos++;
		}
	}

	free(sOutKeys);
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

#endif
